;;;
;;; irchat-pj-mode-line-format.el
;;; last modify : Sun, Jan 3, 1999 by simm-irc@fan.gr.jp / irchat-PJ Project
;;; see file irchat-copyright.el for change log and copyright info
;;;

(provide 'irchat-pj-mode-line-format)

(defvar irchat-pj-chanbuf-mode-line-format-default
  '("" irchat-away-indicator irchat-freeze-indicator ""
    ((if (boundp 'MULE) mc-flag kanji-flag)
     ((minibuffer-window-selected
       (display-minibuffer-mode "m" " ") " ")
      "["
      (minibuffer-window-selected
       (display-minibuffer-mode
	mode-line-egg-mode-in-minibuffer
	mode-line-egg-mode)
       mode-line-egg-mode)
      " ] " mode-line-canna-mode))
    " IRCHAT: Commands" irchat-private-indicator
    " {" irchat-chanbuf-indicator "} "
    irchat-nickname " on " irchat-servername
    (skk-mode skk-input-mode-string)
    " -%-"))

(defvar irchat-pj-chanbuf-mode-line-format-for-egg
  '("" irchat-away-indicator irchat-freeze-indicator ""
    ((if (boundp 'MULE) mc-flag kanji-flag)
     ((minibuffer-window-selected
       (display-minibuffer-mode "m" " ") " ")
      "["
      (minibuffer-window-selected
       (display-minibuffer-mode
	mode-line-egg-mode-in-minibuffer
	mode-line-egg-mode)
       mode-line-egg-mode)
      " ]"))
    " IRCHAT: Commands" irchat-private-indicator
    " {" irchat-chanbuf-indicator "} "
    irchat-nickname " on " irchat-servername " -%-"))

(defvar irchat-pj-chanbuf-mode-line-format-for-canna
  '("" irchat-away-indicator irchat-freeze-indicator ""
    ((if (boundp 'MULE) mc-flag kanji-flag)
     ((minibuffer-window-selected
       (display-minibuffer-mode "m" " ") " ")
      "-" mode-line-canna-mode))
    " IRCHAT: Commands" irchat-private-indicator
    " {" irchat-chanbuf-indicator "} "
    irchat-nickname " on " irchat-servername " -%-"))

(defvar irchat-pj-chanbuf-mode-line-format-simple
  '("" irchat-away-indicator irchat-freeze-indicator ""
    " IRCHAT: Commands" irchat-private-indicator
    " {" irchat-chanbuf-indicator "} "
    irchat-nickname " on " irchat-servername
    (skk-mode skk-input-mode-string)
    " -%-"))

(defvar irchat-pj-chanbuf-mode-line-format-alternative
  '("" irchat-away-indicator irchat-freeze-indicator ""
    ((if (boundp 'MULE) mc-flag kanji-flag)
     ((minibuffer-window-selected
       (display-minibuffer-mode "m" " ") " ")
      "["
      (minibuffer-window-selected
       (display-minibuffer-mode
	mode-line-egg-mode-in-minibuffer
	mode-line-egg-mode)
       mode-line-egg-mode)
      " ]"))
    " IRCHAT: Commands" irchat-private-indicator
    " <" irchat-servername "> " irchat-nickname
    " (" irchat-chanbuf-indicator (skk-mode skk-input-mode-string) ")"
    " -%-"))

(defvar irchat-pj-chanbuf-mode-line-format-alt-egg
  '("" irchat-away-indicator irchat-freeze-indicator ""
    ((if (boundp 'MULE) mc-flag kanji-flag)
     ((minibuffer-window-selected
       (display-minibuffer-mode "m" " ") " ")
      "["
      (minibuffer-window-selected
       (display-minibuffer-mode
	mode-line-egg-mode-in-minibuffer
	mode-line-egg-mode)
       mode-line-egg-mode)
      " ] " mode-line-canna-mode))
    " IRCHAT: Commands" irchat-private-indicator
    " <" irchat-servername "> " irchat-nickname
    " (" irchat-chanbuf-indicator ")"
    " -%-"))

(defvar irchat-pj-chanbuf-mode-line-format-alt-canna
  '("" irchat-away-indicator irchat-freeze-indicator ""
    ((if (boundp 'MULE) mc-flag kanji-flag)
     ((minibuffer-window-selected
       (display-minibuffer-mode "m" " ") " ")
      "-" mode-line-canna-mode))
    " IRCHAT: Commands" irchat-private-indicator
    " <" irchat-servername "> " irchat-nickname
    " (" irchat-chanbuf-indicator (skk-mode skk-input-mode-string) ")"
    " -%-"))

(defvar irchat-pj-chanbuf-mode-line-format-alt-simple
  '("" irchat-away-indicator irchat-freeze-indicator ""
    " IRCHAT: Commands" irchat-private-indicator
    " <" irchat-servername "> " irchat-nickname
    " (" irchat-chanbuf-indicator (skk-mode skk-input-mode-string) ")"
    " -%-"))

(defvar irchat-pj-chanbuf-mode-line-format-minor-mode
  '("" irchat-away-indicator irchat-freeze-indicator ""
    " IRCHAT: Commands" irchat-private-indicator
    " <" irchat-servername "> " irchat-nickname
    " (" irchat-chanbuf-indicator minor-mode-alist ")"
    " -%-"))

(defvar irchat-pj-chanbuf-mode-line-format 'irchat-pj-chanbuf-mode-line-format-default
  "Mode line format for irchat-pj channel buffer.

We irchat-PJ project provides below:
\(for most use\)
  irchat-pj-chanbuf-mode-line-format-default
  irchat-pj-chanbuf-mode-line-format-alternative
\(for minor-mode kana-kanji converting system, like SKK10\)
  irchat-pj-chanbuf-mode-line-format-minor-mode
\(for non-kana-kanji-conversion, or SKK user\)
  irchat-pj-chanbuf-mode-line-format-simple
  irchat-pj-chanbuf-mode-line-format-alt-simple
\(for Wnn user\)
  irchat-pj-chanbuf-mode-line-format-for-egg
  irchat-pj-chanbuf-mode-line-format-alt-egg
\(for Canna user\)
  irchat-pj-chanbuf-mode-line-format-for-canna
  irchat-pj-chanbuf-mode-line-format-alt-canna
So, choose above, or select your defined mode line.

ex.
\(setq irchat-pj-chanbuf-mode-line-format 'irchat-pj-chanbuf-mode-line-format-minor-mode\)

Default is irchat-pj-chanbuf-mode-line-format-default.
")
