;;; irchat-pj-copyright.el --- Copyright for irchat-pj module   -*- coding: ctext; -*-

;; Copyright (C) 1998-2001 by irchat-PJ Project.

;; Author: SHIMADA Mitsunobu <simm@irc.fan.gr.jp>
;; Keywords: irchat-pj, copyright

;; $Id: irchat-pj-copyright.el,v 1.2 2001/06/07 14:11:21 simm Exp $

;; These modules are free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; These modules are distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs; see the file COPYING.  If not, write to
;; the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
;; Boston, MA 02111-1307, USA.

;;; Commentary:

;; You can FTP the latest stable version of PURE from
;;   ftp://ftp.fan.gr.jp/pub/elisp/irchat-pj/

;; You can get the latest stable informaton of PURE from WWW:
;;   http://irc.fan.gr.jp/pj/

;; You can get the latest version of PURE via anonymous CVS like below:
;;   cvs -d :pserver:anonymous@cvs.fan.gr.jp:/home/cvs checkout irchat-pj

;; You can get the latest information of PURE from IRC:
;;   (server)irc.friend.td.nu (port)6660-6669 (channel)#irchat-pj

;; Original copyright of irchat.el is below:
;; <pre>

;;     Internet Relay CHAT interface for GNU Emacs
;;     Copyright (C) 1989 Tor Lillqvist
 
;;     This program is free software; you can redistribute it and/or modify
;;     it under the terms of the GNU General Public License as published by
;;     the Free Software Foundation; either version 1, or (at your option)
;;     any later version.
  
;;     This program is distributed in the hope that it will be useful,
;;     but WITHOUT ANY WARRANTY; without even the implied warranty of
;;     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;     GNU General Public License for more details.
  
;;     You should have received a copy of the GNU General Public License
;;     along with GNU Emacs; if not, write to the Free Software
;;     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  
;;     Author's email address is <tml@hemuli.atk.vtt.fi>
  
;;     Following people have made major improvements to irchat. Also there
;;     are numerous people who have given suggestions and improvements. If 
;;     you think your name should be included here, give us a note...
;; 	   Kai Keinnen		<kmk@cc.tut.fi>
;; 	   Markku Jrvinen	<mta@cc.tut.fi>
;; 	   Jukka Partanen      	<jtp@cs.hut.fi>
;; 	   Kim Nyberg          	<kny@cs.hut.fi>
;; 	   tero t mononen      	<tmo@tekla.fi>

;;     You can ftp the latest version from cs.hut.fi:/pub/irchat

;;     There is a mailing list, irchat@cc.tut.fi for those interested
;;     in developments in irchat. Mail irchat-request@cc.tut.fi if you
;;     are interested in joining.

;; </pre>

;;; Code:

(defconst irchat-pj-pointer-ftp-url "ftp://ftp.fan.gr.jp/pub/elisp/irchat-pj/"
  "URL for IRCHAT-PJ FTP pointer")
(defconst irchat-pj-pointer-www-url "http://irc.fan.gr.jp/pj/"
  "URL for IRCHAT-PJ WWW pointer")
(defconst irchat-pj-pointer-cvs-pserver ":pserver:anonymous@cvs.fan.gr.jp:/home/cvs"
  "PSERVER name for IRCHAT-PJ anonymous-CVS")
(defconst irchat-pj-pointer-cvs-tag "irchat"
  "Tag name for IRCHAT-PJ CVS")
(defconst irchat-pj-pointer-irc-server "irc.friend.td.nu"
  "Server hostname for IRCHAT-PJ IRC channel")
(defconst irchat-pj-pointer-irc-port 6666
  "Server port number for IRCHAT-PJ IRC channel")
(defconst irchat-pj-pointer-irc-channel "#irchat-pj"
  "Channel name for IRCHAT-PJ IRC")

;; That's all
(provide 'irchat-pj-copyright)

;;; irchat-pj-copyright.el ends here
