;;; make.el --- Make file for irchat-pj (w/PURE)

;; Copyright (C) 2000 by Project Pure.

;; Author: SHIMADA Mitsunobu <simm@irc.fan.gr.jp>
;; Keywords: irchat-pj, PURE, make, install

;; $Id: make.el,v 1.7 2001/09/16 15:32:24 simm Exp $

;; This file is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; This file is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs; see the file COPYING.  If not, write to
;; the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
;; Boston, MA 02111-1307, USA.

;;; Commentary:

;; 

;;; Code:

(require 'pure-make)

(defvar make-pj-lispfile-list
  '("irchat.el"
    "irchat-commands.el"
    "irchat-filter.el"
    "irchat-handle.el"
    "irchat-vars.el"
    "irchat-pj-modeline.el"
    "irchat-pj-sound.el"))

(defun make-pj-compile ()
  (pure-make-compile-lisp make-pj-lispfile-list 'irchat 'irchat-vars))

(defun make-pj-install ()
  (make-pj-compile)
  (pure-make-install-current-lisp
   make-pj-lispfile-list
   (or (pure-make-get-argument 'lispdir) "irchat-pj"))
  (let ((dccbin (concat "dcc" pure-make-exec-ext)))
    (if (file-exists-p dccbin)
	(copy-file dccbin (expand-file-name dccbin pure-make-bindir) t t))))

(defun make-pj-package ()
  (make-pj-compile)
  (pure-make-install-package
   make-pj-lispfile-list
   "irchat-pj"
   (or (pure-make-get-argument 'packagedir) pure-make-package-base)
   '("MANIFEST.irchat-pj" . infodir)))

;; That's all
(provide 'make)

;;; make.el ends here
