;;; make.el --- Make file for PURE

;; Copyright (C) 2000 by Project Pure.

;; Author: SHIMADA Mitsunobu <simm@irc.fan.gr.jp>
;; Keywords: PURE, make, install

;; $Id: make.el,v 1.5 2000/11/05 14:52:19 simm Exp $

;; This file is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; This file is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs; see the file COPYING.  If not, write to
;; the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
;; Boston, MA 02111-1307, USA.

;;; Commentary:

;; 

;;; Code:

(require 'pure-make)

(defvar make-pure-lispfile-list
      '("pure-make.el"
	"pure-bl.el"
	"pure-cs.el"
	"pure-cs-detect.el"
	"pure-cs-kana.el"
	("pure-cs-e20.el"    . pure-make-emacs20-p)
	("pure-cs-mule2.el"  . pure-make-mule2-p)
	("pure-cs-nemacs.el" . pure-make-nemacs-p)
	("pure-cs-se.el"     . pure-make-sbemacs-p)
	("pure-cs-xmas.el"   . pure-make-xemacs-p)
	"pure-irc-dcc.el"
	"pure-irc-dcc-common.el"
	"pure-irc-dcc-chat.el"
	"pure-irc-dcc-file.el"
	"pure-irc-send.el"
	"pure-vs.el"
	("pure-vs-e20.el"    . pure-make-emacs20-p)
	("pure-vs-mule2.el"  . pure-make-mule2-p)
	("pure-vs-nemavs.el" . pure-make-nemacs-p)
	("pure-vs-se.el"     . pure-make-sbemacs-p)
	("pure-vs-xmas.el"   . pure-make-xemacs-p)))

(defun make-pure-compile ()
  (pure-make-compile-lisp make-pure-lispfile-list 'pure-cs 'pure-vs))

(defun make-pure-install ()
  (make-pure-compile)
  (pure-make-install-current-lisp
   make-pure-lispfile-list
   (or (car command-line-args-left) "pure")))

(defun make-pure-package ()
  (make-pure-compile)
  (pure-make-install-package
   make-pure-lispfile-list
   "pure"
   (or (car command-line-args-left) pure-make-package-base)))

;; That's all
(provide 'make)

;;; make.el ends here
