;;; make.el --- Make file for PURE

;; Copyright (C) 2000 by Project Pure.

;; Author: SHIMADA Mitsunobu <simm@pure.fan.gr.jp>
;; Keywords: PURE, make, install

;; $Id: make.el,v 1.11 2001/06/05 16:27:39 simm Exp $

;; This file is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; This file is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs; see the file COPYING.  If not, write to
;; the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
;; Boston, MA 02111-1307, USA.

;;; Commentary:

;; 

;;; Code:

(require 'pure-make)

(defvar make-pure-lispfile-list
      '("pure-make.el"
	"pure-generic.el"
	"pure-bl.el"
	"pure-ds.el"
	"pure-cs.el"
	"pure-cs-japanese.el"
	("pure-cs-e20.el"    . pure-make-emacs20-p)
	("pure-cs-mule2.el"  . pure-make-mule2-p)
	("pure-cs-nemacs.el" . pure-make-nemacs-p)
	("pure-cs-se.el"     . pure-make-sbemacs-p)
	("pure-cs-xmas.el"   . pure-make-xemacs-p)
	"pure-irc-send.el"
	"pure-irc-dcc.el"
	"pure-irc-dcc-info.el"
	"pure-pr-dcc-pure.el"
	"pure-pr-dcc-irchat.el"
	"pure-pr-filter.el"
	"pure-pr-ipaddr.el"
	"pure-pr-server.el"
	"pure-vs.el"))

(defun make-pure-compile ()
  (pure-make-compile-lisp make-pure-lispfile-list 'pure-cs 'pure-vs))

(defun make-pure-install ()
  (make-pure-compile)
  (pure-make-install-current-lisp
   make-pure-lispfile-list
   (or (car command-line-args-left) "pure"))
  (let ((puresv (concat "puresv" pure-make-exec-ext))
	(dccput (concat "dccput" pure-make-exec-ext))
	(dccget (concat "dccget" pure-make-exec-ext)))
    (if (file-exists-p (concat "c/" puresv))
	(copy-file (concat "c/" puresv) (expand-file-name puresv pure-make-bindir) t t))
    (if (file-exists-p (concat "c/" dccput))
	(copy-file (concat "c/" dccput) (expand-file-name dccput pure-make-bindir) t t))
    (if (file-exists-p (concat "c/" dccget))
	(copy-file (concat "c/" dccget) (expand-file-name dccget pure-make-bindir) t t))))

(defun make-pure-package ()
  (make-pure-compile)
  (pure-make-install-package
   make-pure-lispfile-list
   "pure"
   (or (car command-line-args-left) pure-make-package-base)
   (cons (cons (concat "puresv" pure-make-exec-ext) "c") 'etcdir)
   (cons (cons (concat "dccput" pure-make-exec-ext) "c") 'etcdir)
   (cons (cons (concat "dccget" pure-make-exec-ext) "c") 'etcdir)))

;; That's all
(provide 'make)

;;; make.el ends here
