;;; pure-cs-se.el --- Old Singlebyte Emacsen specific code for PURE coding-system module

;; Copyright (C) 2000 by Project Pure.

;; Author: SHIMADA Mitsunobu <simm@irc.fan.gr.jp>
;; Keywords: PURE, coding-system, single-byte, old, emacs

;; $Id: pure-cs-se.el,v 1.2 2000/10/18 14:46:49 simm Exp $

;; This file is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; This file is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs; see the file COPYING.  If not, write to
;; the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
;; Boston, MA 02111-1307, USA.

;;; Commentary:

;; PURE means "Primitive Universal Relay-chat Environment"
;; CS means coding-system
;; This module is derived from irchat-pj-specific-other-emacsen.el

;; (Caution) We Project Pure only support MULE-featured Emacsen.

;;; Code:

(defvar pure-cs-enable-mbchars nil
  "Multibyte characters availability flag.
If non-nil, multibyte characters are available.")

(defsubst pure-cs-set-service (service in out)
  service)
(defsubst pure-cs-set-process (process in out)
  process)

(defsubst pure-cs-set-noconv-service (service)
  service)
(defsubst pure-cs-set-noconv-process (process)
  process)

(defun pure-cs-decode-region (beg end code)
  "Do nothing. This function is to compatible with MULE-featured emacsen."
  nil)

(defun pure-cs-encode-region (beg end code)
  "Do nothing. This function is to compatible with MULE-featured emacsen."
  nil)

(defun pure-cs-decode-string (str code)
  "Do nothing. This function is to compatible with MULE-featured emacsen."
  str)

(defun pure-cs-encode-string (str code)
  "Do nothing. This function is to compatible with MULE-featured emacsen."
  str)

;;; That's all
(provide 'pure-cs-se)

;;; pure-cs-se.el ends here
